hdu3360National Treasures (最大匹配,拆点法)

National Treasures

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 1038 Accepted Submission(s): 364

Problem Description

The great hall of the national museum has been robbed few times recently. Everyone is now worried about the security of the treasures on display. To help secure the hall, the museum contracted with a private security company to provide
additional guards to stay in the great hall and keep an eye on the ancient artifacts. The museum would like to hire the minimum number of additional guards so that the great hall is secured.

The great hall is represented as a two dimensional grid of R × C cells. Some cells are already occupied with the museum’s guards. All remaining cells are occupied by artifacts of different types (statues, sculptures, . . . etc.) which can be replaced by new
hired guards. For each artifact, few other cells in the hall are identified as critical points of the artifact depending on the artifact value, type of vault it is kept inside, and few other factors. In other words, if this artifact is going to stay in the
hall then all of its critical points must have guards standing on them. A guard standing in a critical position of multiple artifacts can keep an eye on them all. A guard, however,

can not stand in a cell which contains an artifact (instead, you may remove the artifact to allow the guard to stay there). Also you can not remove an artifact and leave the space free (you can only replace an artifact with a new hired guard).

Surveying all the artifacts in the great hall you figured out that the critical points of any artifact (marked by a ) are always a subset of the 12 neighboring cells as shown in the grid below.

Accordingly, the type of an artifact can be specified as a non-negative integer where the i-th bit is 1 only if critical point number i from the picture above is a critical point of that artifact. For example an artifact of type 595 (in binary 1001010011) can
be pictured as shown in the figure below. Note that bits are numbered from right to left (the right-most bit is bit number 1.) If a critical point of an artifact lies outside the hall grid then it is considered secure.

You are given the layout of the great hall and are asked to find the minimum number of additional guards to hire such that all remaining artifacts are secured.

Input

Your program will be tested on one or more test cases. Each test case is specified using R+1 lines.

The first line specifies two integers (1<= R,C <= 50) which are the dimensions of the museum hall. The next R lines contain C integers separated by one or more spaces. The j-th integer of the i-th row is -1 if cell (i, j) already contains one of the museum’s
guards, otherwise it contains an integer (0 <= T <= 212) representing the type of the artifact in that cell.

The last line of the input file has two zeros.

Output

For each test case, print the following line:

k. G

Where k is the test case number (starting at one,) and G is the minimum number of additional guards to hire such that all remaining artifacts are secured.

Sample Input

1 3
512 -1 2048
2 3
512 2560 2048
512 2560 2048
0 0

Sample Output

1. 0
2. 2

Hint

The picture below shows the solution of the second test case where the  two artifacts in the middle are replaced by guards.

Source

2009 ANARC

这题看似与方向有关,当前位置仅仅与它保护的位置是单向的,但并不是是这种,我们来分析一下。

从当前题意可知,保护位置与被保护位置是奇偶对立的,所以我们能够先把点分成奇偶两部分,每一部分内部是不会有关连的,且每一个点是独一无二的,如果是有向的,保护点指向被保护点,建图,左偶右奇,那么如今是要求最小顶点覆盖,先从左指向右求起,求完之后,如果左边没有匹配的点是被保护点,之后再求右指向左的匹配,但右边部分点己经有匹配的点就不用匹配了,那么也就是求右边未匹配的点和左边未匹配的点匹配,这样匹配是一对一的,所以这种匹配也可觉得是求左边未匹配的点与右边未匹配的点相匹配。----------综上得知,这是一个无向区配。

是一个无向的话就有两种求法:

一种是:把图分成奇偶两部分,求最小顶点覆盖。        还有一种是:求最大匹配。

#include<stdio.h>
#include<vector>
#include<iostream>
using namespace std;
int match[2505],vist[2505];
vector<int>map[2505];
int find(int i)
{
    for(int j=0;j<map[i].size();j++)
    if(!vist[map[i][j]])
    {
        vist[map[i][j]]=1;
        if(match[map[i][j]]==-1||find(match[map[i][j]]))
        {
            match[map[i][j]]=i; return 1;
        }
    }
    return 0;
}
int main()
{
    int dir[12][2]={-1,-2,-2,-1,-2,1,-1,2,1,2,2,1,2,-1,1,-2,-1,0,0,1,1,0,0,-1};
    int n,m,mp[55][55],b_w[55][55],bn,wn,k=0;
    while(scanf("%d%d",&n,&m)>0&&n+m!=0)
    {
        for(int i=0;i<n*m;i++)
        {
            map[i].clear(),match[i]=-1;
        }

        for(int i=0;i<n;i++)
        for(int j=0;j<m;j++)
        scanf("%d",&mp[i][j]);
        for(int i=0;i<n;i++)
        for(int j=0;j<m;j++)
        if(mp[i][j]!=-1)
        {
            int ti,tj;
            for(int e=0;e<12;e++)
            if(mp[i][j]&(1<<e))
            {
                ti=i+dir[e][0]; tj=j+dir[e][1];
                if(ti>=0&&ti<n&&tj>=0&&tj<m&&mp[ti][tj]!=-1)
                {
                    map[ti*m+tj].push_back(i*m+j);
                    map[i*m+j].push_back(ti*m+tj);
                }
            }
        }
        int ans=0;
        for(int i=0;i<n*m;i++)
        {
            for(int j=0;j<n*m;j++)
            vist[j]=0;
            ans+=find(i);
        }
        printf("%d. %d\n",++k,ans/2);
    }
}
时间: 2024-12-25 23:59:15

hdu3360National Treasures (最大匹配,拆点法)的相关文章

UVa 1658 (拆点法 最小费用流) Admiral

题意: 给出一个有向带权图,求从起点到终点的两条不相交路径使得权值和最小. 分析: 第一次听到“拆点法”这个名词. 把除起点和终点以外的点拆成两个点i和i',然后在这两点之间连一条容量为1,费用为0的边.这样就保证了每个点最多经过一次. 其他有向边的容量也是1 然后求从起点到终点的流量为2(这样就保证了是两条路径)的最小费用流. 本来要在加一个源点和汇点来限制流量的,但是这样弧就多了很多.lrj代码中用了很巧妙的方法,避免了这个问题. 1 #include <bits/stdc++.h> 2

Risk UVA - 12264 拆点法+最大流+二分

/** 题目:Risk UVA - 12264 链接:https://vjudge.net/problem/UVA-12264 题意:给n个点的无权无向图(n<=100),每个点有一个非负数ai. 若ai==0则此点归敌方所有,若ai>0则此点归你且上面有ai个属于你的士兵. 保证至少有一个属于你的点与敌方的点相邻.你可以让你的每个士兵最多移动一次 ,每次可以待在原地或者去到相邻的属于你的领地,但每个点至少要留1各士兵, 使得最薄弱的关口尽量坚固.关口是指与敌方点相邻的点,薄弱与坚固分别指兵少

UVA1349 Optimal Bus Route Design 拆点法+最小费用最佳匹配

/** 题目:UVA1349 Optimal Bus Route Design 链接:https://vjudge.net/problem/UVA-1349 题意:lrj入门经典P375 给n个点(n<=100)的有向带权图,找若干个有向圈,每个点恰好属于一个圈.要求权和尽量小.注意即使(u,v) 和(v,y)都存在,他们的权值也不一定相同. 思路:拆点法+最小费用最佳完美匹配. 如果每个点都有一个唯一的后继(不同的点没有相同的后继点,且只有一个后继),那么每个点一定恰好属于一个圈. 联想到二分

UVA1658 Admiral 拆点法解决结点容量(路径不能有公共点,容量为1的时候) 最小费用最大流

/** 题目:UVA1658 Admiral 链接:https://vjudge.net/problem/UVA-1658 题意:lrj入门经典P375 求从s到t的两条不相交(除了s和t外,没有公共点)的路径,使得权值和最小. 思路:拆点法. 除了s,t外.把其他点都拆成两个. 例如点A,拆成A和A'.A指向A'连一条容量为1,花费为0的边. 原来指向A的,仍然指向A点. 原来A指向其他点的,由A'指向它们. 最小费用最大流求流量为2时候的最小费用即可. */ #include<iostrea

poj3422 拆点法x-&gt;x&#39;建立两条边+最小费用最大流

/** 题目:poj3422 拆点法+最小费用最大流 链接:http://poj.org/problem?id=3422 题意:给定n*n的矩阵,含有元素值,初始sum=0.每次从最左上角开始出发,每次向右或者向下一格.终点是右下角. 每经过一个格子,获取它的值,并把该格子的值变成0.问经过k次从左上角到右下角.能得到的数值和最大多少. 思路:我觉得本题元素值全是非负数.要不然不可以过.很多网上的博客代码在有负数情况下过不了. 拆点法+最小费用最大流 建图: 每一个格子x,拆成x,xi, x向x

HDU 2732 Leapin&#39; Lizards(拆点法+最大流)

该题是一道比较简单拆点+最大流的题目,因为每个柱子都有一定的寿命,很容易将其对应成流量,那么处理结点容量的一般方法当然是拆点法 .该题反而对边的容量没有要求,为保险起见可以设成无穷大.   该题的思路很好想,建议独立编写代码 . 推荐题目: 点击打开链接    结点法的一些见解 也可以看这里. 细节参见代码: #include<bits/stdc++.h> using namespace std; typedef long long ll; const int INF = 100000000;

HDU 3998 Sequence (最长递增子序列+最大流SAP,拆点法)经典

Sequence Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1666    Accepted Submission(s): 614 Problem Description There is a sequence X (i.e. x[1], x[2], ..., x[n]). We define increasing subsequ

UVa1658 Admiral(拆点法+最小费用流)

题目链接:http://acm.hust.edu.cn/vjudge/problem/viewProblem.action?id=51253 [思路] 固定流量的最小费用流. 拆点,将u拆分成u1和u2,连边(u1,u2,1,0)表示只能经过该点一次.跑流量为2的最小费用流. [代码] 1 #include<cstdio> 2 #include<cstring> 3 #include<queue> 4 #include<vector> 5 #define F

UVa1658 Admiral (拆点法,最小费用流)

链接:http://vjudge.net/problem/UVA-1658 分析:把2到v-1的每个节点i拆成i和i'两个结点,中间连一条容量为1,费用为0的边,然后求1到v的流量为2的最小费用流即可. 1 #include <cstdio> 2 #include<cstring> 3 #include<queue> 4 #include<vector> 5 #include<algorithm> 6 using namespace std; 7